// SmartRayApiDemoDlg.cpp : implementation file
//

#include "stdafx.h"
#include "SmartRayApiDemo.h"
#include "SmartRayApiDemoDlg.h"
// (include )

#include <Windows.h>
//#include <Winuser.h>

//openCV
#include "cv.h"
#include "highgui.h"


#include "SR_API_public.h"



#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// Global variables
CString g_strMsg;
CString g_errorMsg;
bool g_blStrMsg;
bool g_blErrorMsg;
bool g_blSensorRunning;
int g_iAlive;
int g_iError;
int g_iConnect;
int g_iLaserlight;
int g_iLaserstatus;
int g_iIn[4];
int g_iOut[2];
int g_iFPS;
int g_iNumFrames;
int g_showRemapper;
float g_camRangeMin;
float g_camRangeMax;
float g_scaleZ;
float g_offsetZ;

// Camera/Sensor  description/object
CAMDESC srcam;

// for openCV
IplImage* liveImg=NULL;
IplImage* profImg=NULL;
IplImage* intenImg=NULL;
// for Buffering
IplImage *_profImg = NULL;
IplImage *_intensImg = NULL;

static CvSize	aktsize;

//Image/Profile Buffer full flags 
BOOL Ibuf_full = 0;
BOOL Pbuf_full = 0;
BOOL Intbuf_full = 0;
BOOL Start_flag = 0;
//Return Flags to store window create status
int IretWin = 0; 
int PretWin = 0;
int IntretWin = 0;

// SR_API function prototypes
int CBstatusMsg (CAMDESC* cd, int msgType, int msgdata1, int msgdata2, char *msg);
int CBunknownCommand (CAMDESC* cd);
int CBcommand0x8010 (CAMDESC* cd, int dattyp, int startX, int height, int width, void* pdata); 
int CBcommand0x8020 (CAMDESC* cd, int dattyp, int startX, int height, int width, void* pdata);

// convert 16 bits image to 8-bits image function prototype
void Image16To8(IplImage *srcImg,IplImage *destImg,double minVal,double scaleFact);


// CSmartRayApiDemoDlg dialog
CSmartRayApiDemoDlg::CSmartRayApiDemoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSmartRayApiDemoDlg::IDD, pParent)
	, m_strAPIVersion("")
	, m_isSensorRunning(false)
	, m_isReadRoi(false)
	, m_iLaserStatus(0)
	, m_iNumFrames(0)
	, m_iFPS(0)
	, m_strSerialstr("")
	, m_strMacstr("")
	, m_strPartnumber("")
	, m_strVersion_hw("")
	, m_strVersion_sw("")
	, m_iWidth(0)
	, m_iHeight(0)
	, m_roiWidth(0)
	, m_roiHeight(0)
	, m_startX(0)
	, m_startY(0) 
	, m_setDoubleExp(0) 
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	g_showRemapper = 0;
	m_camRangeMin = g_camRangeMin = -10.0f;
	m_camRangeMax = g_camRangeMax = 10.0f;
	m_offsetZ = g_offsetZ = 30.0f; // 30mm (approx. -5mm nominal distance)
	m_scaleZ = g_scaleZ = 0.01f; // 10m resolution
	m_firstExpTime = 300; //300 microseconds
	m_secondExpTime = 1000; // 1000 microseconds
}

void CSmartRayApiDemoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);

	DDX_Control(pDX, IDC_START, m_startButton);
	DDX_Control(pDX, IDC_STOP, m_stopButton);
	DDX_Control(pDX, IDC_CHECKREMAPPER, m_remapButton);
	DDX_Control(pDX, IDC_CHECKDOUBLEEXP, m_doubleExpButton);
	DDX_Control(pDX, IDC_SECEXPEDIT, m_secondExpEdit);
	DDX_Control(pDX, IDC_LIST1, m_ctrlMessageBox);
	m_ctrlMessageBox.SetHorizontalExtent(200);
	DDX_Text(pDX, IDC_APIVERSION, m_strAPIVersion);
	DDX_Control(pDX, IDC_CLEARERROR, m_ctrlClearError);
	DDX_Text(pDX, IDC_SERIALNO, m_strSerialstr);
	DDX_Text(pDX, IDC_MACNO, m_strMacstr);
	DDX_Text(pDX, IDC_PARTNUMBER, m_strPartnumber);
	DDX_Text(pDX, IDC_HWVERSION, m_strVersion_hw);
	DDX_Text(pDX, IDC_SWVERSION, m_strVersion_sw);
	DDX_Text(pDX, IDC_WIDTH, m_iWidth);
	DDX_Text(pDX, IDC_HEIGHT, m_iHeight);
	DDX_Text(pDX, IDC_CAMRANGMIN, m_camRangeMin);
	DDX_Text(pDX, IDC_CAMRANGMAX, m_camRangeMax);
	DDV_MinMaxFloat(pDX, m_camRangeMin, -10.0f, 10.0f);
	DDV_MinMaxFloat(pDX, m_camRangeMax, -10.0f, 10.0f);
	DDX_Text(pDX, IDC_SCALEZ, m_scaleZ);
	DDV_MinMaxFloat(pDX, m_scaleZ, 0.001f, 100.00f);
	DDX_Text(pDX, IDC_OFFSETZ, m_offsetZ);
	DDV_MinMaxFloat(pDX, m_offsetZ, -100.0f, 100.00f);
	DDX_Control(pDX, IDC_OFFSETZ, m_offsetZEdit);
	DDX_Control(pDX, IDC_SCALEZ, m_scaleZEdit);
	DDX_Control(pDX, IDC_CAMRANGMIN, m_camRangeMinEdit);
	DDX_Control(pDX, IDC_CAMRANGMAX, m_camRangeMaxEdit);
	DDX_Text(pDX, IDC_WIDTHEDIT, m_roiWidth);
	DDX_Text(pDX, IDC_HEIGHTEDIT, m_roiHeight);
	DDX_Text(pDX, IDC_STARTXEDIT, m_startX);
	DDX_Text(pDX, IDC_STARTYEDIT, m_startY);
	DDX_Text(pDX, IDC_FIRSTEXPEDIT, m_firstExpTime);
	DDX_Text(pDX, IDC_SECEXPEDIT, m_secondExpTime);
}

BEGIN_MESSAGE_MAP(CSmartRayApiDemoDlg, CDialog)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_TIMER ()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_CLEARERROR, &CSmartRayApiDemoDlg::OnBnClickedClearerror)
	ON_BN_CLICKED(IDC_LASERSTATUS, &CSmartRayApiDemoDlg::OnBnClickedLaserstatus)
	ON_BN_CLICKED(IDC_UPDATE, &CSmartRayApiDemoDlg::OnBnClickedUpdate)
	ON_BN_CLICKED(IDC_LOADPARAM, &CSmartRayApiDemoDlg::OnBnClickedLoadparam)
	ON_BN_CLICKED(IDC_START, &CSmartRayApiDemoDlg::OnBnClickedStart)
	ON_BN_CLICKED(IDC_STOP, &CSmartRayApiDemoDlg::OnBnClickedStop)
	ON_BN_CLICKED(IDC_GETSERIAL, &CSmartRayApiDemoDlg::OnBnClickedGetserial)
	ON_BN_CLICKED(IDC_GETMAC, &CSmartRayApiDemoDlg::OnBnClickedGetmac)
	ON_BN_CLICKED(IDC_GETPART, &CSmartRayApiDemoDlg::OnBnClickedGetpart)
	ON_BN_CLICKED(IDC_GETCAMVERSION, &CSmartRayApiDemoDlg::OnBnClickedGetcamversion)
	ON_BN_CLICKED(IDC_GETSIZE, &CSmartRayApiDemoDlg::OnBnClickedGetsize)
	ON_BN_CLICKED(IDC_BUTTON1, &CSmartRayApiDemoDlg::OnBnClickedButton1)
	ON_BN_CLICKED(IDC_LOADLUT, &CSmartRayApiDemoDlg::OnBnClickedLoadlut)
	ON_BN_CLICKED(IDC_CHECKREMAPPER, &CSmartRayApiDemoDlg::OnBnClickedCheckremapper)
	ON_BN_CLICKED(IDC_APPLYBUTTON, &CSmartRayApiDemoDlg::OnBnClickedApplybutton)
	ON_BN_CLICKED(IDC_CHECKDOUBLEEXP, &CSmartRayApiDemoDlg::OnBnClickedCheckdoubleexp)
END_MESSAGE_MAP()


// CSmartRayApiDemoDlg message handlers
BOOL CSmartRayApiDemoDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	SetTimer (1, 50, 0);
	adBtnConnect.SubclassDlgItem(IDC_CONNECT, this, DKGREEN, GREEN);
	adBtnAlive.SubclassDlgItem(IDC_ALIVE, this, DKGREEN, GREEN);
	adBtnError.SubclassDlgItem(IDC_ERROR, this, DKGREEN, RED);
	adBtnLaserlight.SubclassDlgItem(IDC_LASERLIGHT, this, DKGREEN, GREEN);
	adBtnIn0.SubclassDlgItem(IDC_IN0, this, DKGREEN, GREEN);
	adBtnIn1.SubclassDlgItem(IDC_IN1, this, DKGREEN, GREEN);
	adBtnIn2.SubclassDlgItem(IDC_IN2, this, DKGREEN, GREEN);
	adBtnIn3.SubclassDlgItem(IDC_IN3, this, DKGREEN, GREEN);
	adBtnOut0.SubclassDlgItem(IDC_OUT0, this, DKGREEN, GREEN);
	adBtnOut1.SubclassDlgItem(IDC_OUT1, this, DKGREEN, GREEN);

	//=======================================
	// Get Version
	//=======================================
    {
	 char *apiversion=NULL;
	 char msg[260];
	 int ret = INT_MAX;
	ret = SR_API_GetAPIVersion(&apiversion);
	if (ret) 
	{	
		sprintf (msg, "API Version Read Error. Errorcode: %d", ret); 
		g_errorMsg = msg;
		g_blErrorMsg = true;
		MessageBox (msg, "Error!");
		
	}
	m_strAPIVersion = apiversion;
	}
	//=======================================
	// API Init
	// initializes and installs a message callback
	//=======================================
	SR_API_Init (CBstatusMsg);

	//=======================================
	// Register Data Callback channels
	// 0x8010, 0x8020 etc. are command numbers [hex] found in module send TCP in parameter set 
	// The command numbers define which CB gets activated by data sent by sensor 
	//=======================================
	SR_API_RegisterUserCB (SRCB_CAMDATAMODE, 0x8010, CBcommand0x8010); //default live image
	SR_API_RegisterUserCB (SRCB_CAMDATAMODE, 0x8020, CBcommand0x8020); //default profile image for SR1400/3400

	
	//=======================================W
	// Define a camera  (you can define up to INSTANCES cameras/sensors)
	//=======================================
	//sensor index (increment by one for each new sensor if you want to implement >1 sensors)
	srcam.cam_index = 0;
	// sensor name
	strcpy_s (srcam.name, "sensor0");
	// sensor IP address (can be changed ATTENTION!!!! Don't forget new IPAddress!)
	strcpy_s (srcam.IPAdr, DEFAULT_IP_ADR);
	// sensor IP port number (can be changed ATTENTION!!!! Don't forget new IPAddress!) 
	srcam.portnum = DEFAULT_PORT_NUM;
	// install data callback for all received data with unknown command (no preprocessing is done on this data)
	srcam.usercbf = CBunknownCommand;

	//=======================================
	// Connect to the sensor
	// reconnect automatically if disconnected
	// disconnect if alive signal timeout
	//======================================= 
	SR_API_StartCameraConnectionManagement (&srcam);

	//=======================================
	// When connection is established
	// 1. Press Load Parameter
	// 2. Press Start
	// 3. watch video
	// 4. Press Stop
	// 5. get sensor information if you like
	//======================================= 

	//disable the stop button
	m_stopButton.EnableWindow(FALSE);

	//disable the remapper options
	m_offsetZEdit.EnableWindow(FALSE);
	m_scaleZEdit.EnableWindow(FALSE);
	m_camRangeMinEdit.EnableWindow(FALSE);
	m_camRangeMaxEdit.EnableWindow(FALSE);
	m_secondExpEdit.EnableWindow(FALSE);
	
	UpdateData(FALSE);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

CSmartRayApiDemoDlg::~CSmartRayApiDemoDlg()
{
	//close opencv windows
	cvDestroyAllWindows();
	
	//release opencv resources
	if(liveImg!= NULL)
	{
		cvReleaseImageHeader(&liveImg);
		liveImg = NULL;
	}
	if(profImg != NULL)
	{
		cvReleaseImage(&profImg);
		profImg = NULL;
	}
	if(intenImg != NULL)
	{
		cvReleaseImage(&intenImg);
		intenImg = NULL;
	}

	//stop the camera
	SR_API_StopCam (&srcam);
	//=======================================
	// Disconnect from sensor and stop trying to connect
	//=======================================
	SR_API_StopCameraConnectionManagement (&srcam);
	
	//=======================================
	// Finish
	//=======================================
	SR_API_Exit (); 

}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.
void CSmartRayApiDemoDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags 
//  the minimized window.
HCURSOR CSmartRayApiDemoDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


//check the status of the sensor using window timer
void CSmartRayApiDemoDlg::OnTimer(UINT_PTR nIDEvent) 
{
	int nItem;

	//this nIDEvent is used to set a correct ROI
	if(nIDEvent == 2)
	{
		int width = 0;
		int height = 0;
		//set the default region of interest to the sensor size 
		SR_API_GetSensorSize(&srcam,&width,&height);
		m_roiHeight = height;
		m_roiWidth = width;

		SetDlgItemInt(IDC_HEIGHTEDIT, m_roiHeight);
		SetDlgItemInt(IDC_WIDTHEDIT, m_roiWidth);
		KillTimer(m_roiTimer); 
	}

	//show the camera message
	if (g_blStrMsg || g_blErrorMsg)
	{
		nItem = m_ctrlMessageBox.GetCount();

		if(g_blStrMsg)
		{
			g_blStrMsg = false;
			m_ctrlMessageBox.InsertString (nItem, g_strMsg);
		}

		if(g_blErrorMsg)
		{
			g_blErrorMsg = false;
			m_ctrlMessageBox.InsertString (nItem, g_errorMsg);
		}
		m_ctrlMessageBox.SetCurSel (nItem);

		if(g_strMsg.GetLength() > 200)
			m_ctrlMessageBox.SetHorizontalExtent(g_strMsg.GetLength());

		if (nItem > 200)
		{
			for (nItem = 0; nItem < 1; nItem++)
				m_ctrlMessageBox.DeleteString (nItem);
		}
	}

	//disable the remapper options
	if (srcam.connectionstate != STATE_CAMERA_CONNECTED)
	{
		m_remapButton.EnableWindow(FALSE);
		m_doubleExpButton.EnableWindow(FALSE);
	} 
	else 
	{
		m_doubleExpButton.EnableWindow(TRUE);

		if(srcam.lut == NULL)
		{
			m_remapButton.EnableWindow(FALSE);
		}
		else
		{
			m_remapButton.EnableWindow(TRUE);
		}
	}

	if(srcam.lut != NULL)
	{
		m_remapButton.EnableWindow(TRUE);
	}
	else
	{
		m_remapButton.EnableWindow(FALSE);
	}

	if (g_iConnect)
	{
		adBtnConnect.SetBackGround(GREEN);
	}
	else
	{
		adBtnConnect.SetBackGround(DKGREEN);
	}

	if (g_iAlive)
	{
		adBtnAlive.SetBackGround(GREEN);
	}
	else
	{
		adBtnAlive.SetBackGround(DKGREEN);
	}

	if (g_iError)
	{
		adBtnError.SetBackGround(RED);
	}
	else
	{
		adBtnError.SetBackGround(DKGREEN);
	}

	if (g_iLaserlight)
	{
		adBtnLaserlight.SetBackGround(GREEN);
	}
	else
	{
		adBtnLaserlight.SetBackGround(DKGREEN);
	}

	if (g_iIn[0])
	{
		adBtnIn0.SetBackGround(GREEN);
	}
	else
	{
		adBtnIn0.SetBackGround(DKGREEN);
	}

	if (g_iIn[1])
	{
		adBtnIn1.SetBackGround(GREEN);
	}
	else
	{
		adBtnIn1.SetBackGround(DKGREEN);
	}

	if (g_iIn[2])
	{
		adBtnIn2.SetBackGround(GREEN);
	}
	else
	{
		adBtnIn2.SetBackGround(DKGREEN);
	}

	if (g_iIn[3])
	{
		adBtnIn3.SetBackGround(GREEN);
	}
	else
	{
		adBtnIn3.SetBackGround(DKGREEN);
	}

	if (g_iOut[0])
	{
		adBtnOut0.SetBackGround(GREEN);
	}
	else
	{
		adBtnOut0.SetBackGround(DKGREEN);
	}

	if (g_iOut[1])
	{
		adBtnOut1.SetBackGround(GREEN);
	}
	else
	{
		adBtnOut1.SetBackGround(DKGREEN);
	}

	//update all status
	m_iFPS = g_iFPS;
	m_iNumFrames = g_iNumFrames;
	g_blSensorRunning = m_isSensorRunning;

	//set timer to read the correct ROI
	if(g_iConnect && !m_isReadRoi)
	{
		m_roiTimer = SetTimer(2, 1000, NULL);
		m_isReadRoi = true;
	}

	SetDlgItemInt(IDC_FPS,m_iFPS);
	SetDlgItemInt(IDC_NUMF,m_iNumFrames);

	
	//------------------Display Windows---------------------//
	//Live Image
	if (Ibuf_full & Start_flag)
	{	
		if (!IretWin)
			IretWin = cvNamedWindow("Live Image",CV_WINDOW_AUTOSIZE);
		else if(liveImg != NULL)
		{
			cvShowImage("Live Image",liveImg);
			Ibuf_full = 0;
		}
	}

	//Profile Image
	if (Pbuf_full & Start_flag)
	{	
		if (!PretWin)
			PretWin = cvNamedWindow("Profil Image",CV_WINDOW_AUTOSIZE);
		else if(_profImg != NULL)
		{
			cvShowImage("Profil Image",_profImg);
			cvReleaseImage(&_profImg);
			_profImg = NULL;
			Pbuf_full = 0;
		}
	}

	//Intensity Image
	if (Intbuf_full & Start_flag)
	{	
		if (!IntretWin)
			IntretWin = cvNamedWindow("Intensity Image",CV_WINDOW_AUTOSIZE);
		else if(_intensImg != NULL)
		{
			cvShowImage("Intensity Image",_intensImg);
			cvReleaseImage(&_intensImg);
			_intensImg = NULL;
			Intbuf_full = 0;
		}
	}
	
	//------------------------------------------------------//


	// Call base class handler.
	CDialog::OnTimer(nIDEvent);
}


// clear error led
void CSmartRayApiDemoDlg::OnBnClickedClearerror()
{
	if(g_iError == 1)
	{
		g_iError = 0;
		adBtnError.SetBackGround(DKGREEN);
		OnBnClickedStop();
	}
	else
	{
		return;
	}
}

// Update sensor
void CSmartRayApiDemoDlg::OnBnClickedUpdate()
{
	//==============================================
	// check if sensor is connected
	// if not buttons won't work
	if (srcam.connectionstate != STATE_CAMERA_CONNECTED)
	{
		MessageBox("The camera is not connected.", "Error", MB_ICONERROR | MB_OK);
		return;
	}
	//==============================================

	OPENFILENAME ofn;       // common dialog box structure
	char szFile[260];       // buffer for file name
	HWND hwnd;              // owner window

	// Initialize OPENFILENAME
	ZeroMemory(&ofn, sizeof(ofn));
	ofn.lStructSize = sizeof(ofn);
	ofn.hwndOwner = hwnd = NULL;
	ofn.lpstrFile = szFile;

	//
	// Set lpstrFile[0] to '\0' so that GetOpenFileName does not 
	// use the contents of szFile to initialize itself.
	//
	ofn.lpstrFile[0] = '\0';
	ofn.nMaxFile = sizeof(szFile);
	ofn.lpstrFilter = "fup\0*.fup\0aup\0*.aup\0";
	ofn.nFilterIndex = 1;
	ofn.lpstrFileTitle = NULL;
	ofn.nMaxFileTitle = 0;
	ofn.lpstrInitialDir = NULL;
	ofn.Flags = OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST;

	// choose an update file
	if (GetOpenFileName(&ofn)==TRUE)
	{
		std::string fileName = ofn.lpstrFile;
		strcpy_s(szFile,fileName.c_str());

		// plug sensor off and on when update is completed Attention!!! Wait for complete message!
		int ret = SR_API_Update_Cam (&srcam, szFile);
		if (ret < 0)
		{
			MessageBox("The camera could not be updated.", "Error", MB_ICONERROR | MB_OK);
			return;
		}

	}
}

// Load Parameter set
void CSmartRayApiDemoDlg::OnBnClickedLoadparam()
{
	//==============================================
	// check if sensor is connected
	// if not buttons won't work
	if (srcam.connectionstate != STATE_CAMERA_CONNECTED)
	{
		MessageBox("The camera is not connected.", "Error", MB_ICONERROR | MB_OK);
		return;
	}
	//==============================================

	OPENFILENAME ofn;       // common dialog box structure
	char szFile[260];       // buffer for file name
	HWND hwnd;              // owner window

	// Initialize OPENFILENAME
	ZeroMemory(&ofn, sizeof(ofn));
	ofn.lStructSize = sizeof(ofn);
	ofn.hwndOwner = hwnd = NULL;
	ofn.lpstrFile = szFile;

	//
	// Set lpstrFile[0] to '\0' so that GetOpenFileName does not 
	// use the contents of szFile to initialize itself.
	//
	ofn.lpstrFile[0] = '\0';
	ofn.nMaxFile = sizeof(szFile);
	ofn.lpstrFilter = "par\0*.par\0";
	ofn.nFilterIndex = 1;
	ofn.lpstrFileTitle = NULL;
	ofn.nMaxFileTitle = 0;
	ofn.lpstrInitialDir = NULL;
	ofn.Flags = OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST | OFN_NOCHANGEDIR;

	// choose a parameter file
	if (GetOpenFileName(&ofn)==TRUE)
	{	
		std::string fileName = ofn.lpstrFile;
		strcpy_s(szFile,fileName.c_str());

		int ret = SR_API_ReadCamParsFromFile(szFile);
		
		if(ret < 0)
		{
			if(ret == -2)
			{
				MessageBox("The parameters are not compatible to this API.", "Error", MB_ICONERROR | MB_OK);
				return;
			}
			else
			{
				MessageBox("The parameters could not be loaded.", "Error", MB_ICONERROR | MB_OK);
				return;
			}
		}
	
		 
			int errcode = INT_MAX;
			char msg[260];
			errcode = SR_API_SendParsToCam (&srcam);
			
			if (!(!errcode))
			{	
				sprintf (msg, "API Send Parameter Error. Errorcode %d.", errcode); 
				g_errorMsg = msg;
				g_blErrorMsg = true;
				MessageBox (msg, "Error!");	
			} 
		
	}
}

// Start button clicked
void CSmartRayApiDemoDlg::OnBnClickedStart()
{		
	//==============================================
	// check if sensor is connected
	// if not buttons won't work
	if (srcam.connectionstate != STATE_CAMERA_CONNECTED)
	{
		MessageBox("The camera is not connected.", "Error", MB_ICONERROR | MB_OK);
		return;
	}

	//start the camera
	int ret = SR_API_StartCam (&srcam);

	//check whether the sensor can start
	if(ret == 0)
	{
		m_isSensorRunning = true;
		Start_flag = 1;
	}

	if(m_isSensorRunning)
	{
		//openCV
		aktsize.height=0;
		aktsize.width=0;

		//enable stop button and disable start button
		m_stopButton.EnableWindow(TRUE);
		m_startButton.EnableWindow(FALSE);
	}
}

// Stop button clicked
void CSmartRayApiDemoDlg::OnBnClickedStop()
{
	//==============================================
	// check if sensor is connected
	// if not buttons won't work
	if (srcam.connectionstate != STATE_CAMERA_CONNECTED)
	{
		MessageBox("The camera is not connected.", "Error", MB_ICONERROR | MB_OK);
		return;
	}
	//==============================================



	//stop the camera
	int ret = SR_API_StopCam (&srcam);

	//check whether the sensor can stop
	if(ret == 0)
	{
		m_isSensorRunning = false;
		Start_flag = 0;
	}

	
	//openCV
	if(!m_isSensorRunning)
	{
		aktsize.height=0;
		aktsize.width=0;
		cvDestroyAllWindows();
		// Buffer flags for profile and Live Image 	
		Ibuf_full = 0;
		Pbuf_full = 0;
		Intbuf_full = 0;
		// Window Creation flags, Initialized to 0 since created windows are destroyed
		IretWin = 0;
		PretWin = 0;
		IntretWin = 0;

		//enable start button and disable stop button
		m_startButton.EnableWindow(TRUE);
		m_stopButton.EnableWindow(FALSE);

		//reset the frame number
		g_iNumFrames = 0;
	}


}

// Get serial number
void CSmartRayApiDemoDlg::OnBnClickedGetserial()
{
	//==============================================
	// check if sensor is connected
	// if not buttons won't work
	if (srcam.connectionstate != STATE_CAMERA_CONNECTED)
	{
		MessageBox("The camera is not connected.", "Error", MB_ICONERROR | MB_OK);
		return;
	}
	//==============================================
		
	//SR_API_SaveLutToCamera (&srcam);

	//Get the serial number of the camera
	unsigned char serial[SERIALSIZE];
	static char strserial[32];
	int errcode=INT_MAX;

	errcode = SR_API_GetSerial (&srcam, serial);
	
	TCHAR str[255];
	if (!(!errcode))
	{	
		_stprintf(str, _T("Read Serial Error. Errorcode: %d"),errcode);
		MessageBox(str);
	}

	sprintf (strserial,"%02d-%02d-%02d-%02d-%02d", serial[0],serial[1],serial[2],serial[3],serial[4]);

	m_strSerialstr = strserial;

	UpdateData (FALSE);
}

// Get MAC address
void CSmartRayApiDemoDlg::OnBnClickedGetmac()
{
	//==============================================
	// check if sensor is connected
	// if not buttons won't work
	if (srcam.connectionstate != STATE_CAMERA_CONNECTED)
	{
		MessageBox("The camera is not connected.", "Error", MB_ICONERROR | MB_OK);
		return;
	}
	//==============================================

	//Get the MAC address of the camera
	unsigned char mac[MACSIZE];
	static char strmac[32];
	int errcode=INT_MAX;

	errcode = SR_API_GetMACAdr (&srcam, mac);
	
	TCHAR str[255];
	if (!(!errcode))
	{	
		_stprintf(str, _T("Read MAC Address Error. Errorcode: %d"),errcode);
		MessageBox(str);
	}

	sprintf (strmac,"%02x.%02x.%02x.%02x.%02x.%02x", mac[0],mac[1],mac[2],mac[3],mac[4],mac[5]);

	m_strMacstr = strmac;

	UpdateData (FALSE);
}

// Get part number (=sensor type)
void CSmartRayApiDemoDlg::OnBnClickedGetpart()
{
	//==============================================
	// check if sensor is connected
	// if not buttons won't work
	if (srcam.connectionstate != STATE_CAMERA_CONNECTED)
	{
		MessageBox("The camera is not connected.", "Error", MB_ICONERROR | MB_OK);
		return;
	}
	//==============================================

	char partNumber[16];  

	//Get the sensor type
	SR_API_GetSensorType (&srcam, partNumber);

	m_strPartnumber = partNumber;

	UpdateData (FALSE);
}

// Get sensor versions
void CSmartRayApiDemoDlg::OnBnClickedGetcamversion()
{
	//==============================================
	// check if sensor is connected
	// if not buttons won't work
	if (srcam.connectionstate != STATE_CAMERA_CONNECTED)
	{
		MessageBox("The camera is not connected.", "Error", MB_ICONERROR | MB_OK);
		return;
	}
	//==============================================

	char version_sw[CAMVERSIONSIZE], version_hw[CAMVERSIONSIZE];   

	//Get the camera version
	SR_API_GetCamVersions (&srcam, version_sw, version_hw);  
	
	m_strVersion_hw = version_hw;
	m_strVersion_sw = version_sw;

	UpdateData (FALSE);
}

// Get sensor size (imager size)
void CSmartRayApiDemoDlg::OnBnClickedGetsize()
{
	//==============================================
	// check if sensor is connected
	// if not buttons won't work
	if (srcam.connectionstate != STATE_CAMERA_CONNECTED)
	{
		MessageBox("The camera is not connected.", "Error", MB_ICONERROR | MB_OK);
		return;
	}
	//==============================================

	int width, height;   

	//Get imager size
	SR_API_GetSensorSize (&srcam, &width, &height);
         
	m_iWidth = width;
	m_iHeight = height;

	UpdateData (FALSE);
}

// Enable / Disable Laser
void CSmartRayApiDemoDlg::OnBnClickedLaserstatus()
{
	//==============================================
	// check if sensor is connected
	// if not buttons won't work
	if (srcam.connectionstate != STATE_CAMERA_CONNECTED)
	{
		MessageBox("The camera is not connected.", "Error", MB_ICONERROR | MB_OK);
		return;
	}
	//==============================================

	//Enable the laser
	if(g_iLaserlight == 0)
	{
		g_iLaserlight = 1;
	}
	else
	{
		g_iLaserlight = 0;
	}

	//Setup the laser
	SR_API_SetLaser (&srcam, LASER_CONTINOUS, LASER_SW_ONLY, g_iLaserlight, 100); //the last argument is laser power: 0..100[%]   

}

//connect the Smartray label to Smartray web page 
void CSmartRayApiDemoDlg::OnBnClickedButton1()
{
	ShellExecute(this->GetSafeHwnd(), "open", "iexplore.exe", 
			"http://www.smartray.de", NULL, SW_SHOWNORMAL);
}

// load the LUT file to the sensor
void CSmartRayApiDemoDlg::OnBnClickedLoadlut()
{
	//==============================================
	// check if sensor is connected
	// if not buttons won't work
	if (srcam.connectionstate != STATE_CAMERA_CONNECTED)
	{
		MessageBox("The camera is not connected.", "Error", MB_ICONERROR | MB_OK);
		return;
	}
	//==============================================

	OPENFILENAME ofn;       // common dialog box structure
	char szFile[260];       // buffer for file name
	HWND hwnd;              // owner window
	char info[1024];

	// Initialize OPENFILENAME
	ZeroMemory(&ofn, sizeof(ofn));
	ofn.lStructSize = sizeof(ofn);
	ofn.hwndOwner = hwnd = NULL;
	ofn.lpstrFile = szFile;

	ofn.lpstrFile[0] = '\0';
	ofn.nMaxFile = sizeof(szFile);
	ofn.lpstrFilter = "lut\0*.lut\0";
	ofn.nFilterIndex = 1;
	ofn.lpstrFileTitle = NULL;
	ofn.nMaxFileTitle = 0;
	ofn.lpstrInitialDir = NULL;
	ofn.Flags = OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST | OFN_NOCHANGEDIR;

	// choose a parameter file
	if (GetOpenFileName(&ofn)==TRUE)
	{		
		std::string fileName = ofn.lpstrFile;
		strcpy_s(szFile,fileName.c_str());

		//Load the look-up table file to the sensor
		int ret = SR_API_LoadLutFromFile (&srcam, szFile, info); 
		
		if(ret <0)
		{
			MessageBox("The LUT file is not loaded.", "Error", MB_ICONERROR | MB_OK);
			return;
		}
	}
}

//enable/disable the remapper option
void CSmartRayApiDemoDlg::OnBnClickedCheckremapper()
{

	if(g_showRemapper == 0)
	{
		g_showRemapper = 1;

		m_offsetZEdit.EnableWindow(TRUE);
		m_scaleZEdit.EnableWindow(TRUE);
		m_camRangeMinEdit.EnableWindow(TRUE);
		m_camRangeMaxEdit.EnableWindow(TRUE);
	}
	else
	{
		g_showRemapper = 0;

		m_offsetZEdit.EnableWindow(FALSE);
		m_scaleZEdit.EnableWindow(FALSE);
		m_camRangeMinEdit.EnableWindow(FALSE);
		m_camRangeMaxEdit.EnableWindow(FALSE);
	}
}

//enable/disable the double exposure time
void CSmartRayApiDemoDlg::OnBnClickedCheckdoubleexp()
{
	if(m_setDoubleExp == 0)
	{
		m_setDoubleExp = 1;

		m_secondExpEdit.EnableWindow(TRUE);
	}
	else
	{
		m_setDoubleExp = 0;

		m_secondExpEdit.EnableWindow(FALSE);
	}
}

//Apply button clicked
void CSmartRayApiDemoDlg::OnBnClickedApplybutton()
{
	UpdateData(TRUE);
	
	//==============================================
	// check if sensor is connected
	// if not buttons won't work
	if (srcam.connectionstate != STATE_CAMERA_CONNECTED)
	{
		MessageBox("The camera is not connected.", "Error", MB_ICONERROR | MB_OK);
		return;
	}

	//stop first the camera
	OnBnClickedStop();

	int width = 0;
	int height= 0;
	
	//check the remapper condition
	if(g_showRemapper == 1)
	{
		g_offsetZ = m_offsetZ;
		g_scaleZ = m_scaleZ;
		g_camRangeMin = m_camRangeMin;
		g_camRangeMax = m_camRangeMax;
	}

	//check the exposure time condition
	if(m_firstExpTime>0)
	{
		if(m_setDoubleExp)
		{
			if((m_firstExpTime<m_secondExpTime)&&(m_secondExpTime>0))
			{
				//set the exposure time
				SR_API_SetExposure(&srcam, 0, m_setDoubleExp, m_firstExpTime, m_secondExpTime);
			}
			else
			{
				MessageBox("The first exposure time should be less than the second exposure time.", "Error", MB_ICONERROR | MB_OK);
				return;
			}
		}
		else
		{
			//set the exposure time
			SR_API_SetExposure(&srcam, 0, m_setDoubleExp, m_firstExpTime, m_secondExpTime);
		}
	}
	else
	{
		MessageBox("Please correct the exposure time.", "Error", MB_ICONERROR | MB_OK);
		return;
	}

	SR_API_GetSensorSize (&srcam, &width, &height);

	//check the region of interest
	if((m_roiWidth<=width)&&(m_roiWidth>0)&&(m_roiHeight<=height)&&(m_roiHeight>0))
	{
		//set the region of interest
		SR_API_SetImager(&srcam, 0, m_startX, m_startY, m_roiWidth, m_roiHeight, 0, 0);
	}
	else
	{
		MessageBox("Please correct the region of interest.", "Error", MB_ICONERROR | MB_OK);
		return;
	}
}

/****************************************************************************
* CBstatusMsg																*
*																			*
* message and status callback 								      			*
*****************************************************************************/
int CBstatusMsg (CAMDESC* cd, int msgType, int msgdata1, int msgdata2, char *msg)
{
	static int alive_toggle; 

	if(msg == NULL)
	{
		//No message data available
		return -1;
	}

	//Ethernet connection messages
	if (msgType == MSGTYPE_CONNECTION)
	{
		g_strMsg = msg;
		g_blStrMsg = true;

		// TCP/IP connection established
		if(msgdata1 == CAMERA_CONNECTED)
		{
			g_iConnect = 1;
		}

		// disconnected
		else
		{
			g_iConnect = 0;
			alive_toggle = 0;
		}
	}
	else if (msgType == MSGTYPE_INFO) 	// Info messages
	{
		g_strMsg = msg;
		g_blStrMsg = true;

	}
	else if (msgType == MSGTYPE_ERROR) 	// Error messages
	{
		g_errorMsg = msg;
		g_blErrorMsg = true;

		g_iError = 1;
	}
	else if (msgType == MSGTYPE_DATA && msgdata1 == DATATYPE_IO) 	// Sensor IO and general data (sensor sends this every 200ms) 
	{

		// Alive signal
		if (alive_toggle)
		{
			alive_toggle = 0;
		}
		else
		{
			alive_toggle = 1;
		}

		// display
		g_iAlive = alive_toggle;

		// Digital input status (via CAMDESC* cd e.g. cd->digio_in[0] = DigIn0)
		// display
		g_iIn[0] = cd->digio_in[0];
		g_iIn[1] = cd->digio_in[1];
		g_iIn[2] = cd->digio_in[2];
		g_iIn[3] = cd->digio_in[3];

		// Digital output status (via CAMDESC* cd e.g. cd->digio_out[0] = DigOut0)
		// display
		g_iOut[0] = cd->digio_out[0];
		g_iOut[1] = cd->digio_out[1];

		// Laser Status (enabled - disabled) 
		g_iLaserstatus = cd->laser_status;

		// Laser light on/off
		g_iLaserlight = cd->laserlight;

		// Frames per second (current/last INTERNAL! framerate of the sensor)
		g_iFPS = cd->fps;

	}

	return 0;
}

/****************************************************************************
* CB for data with not registered command numbers 							*
*																			*
*****************************************************************************/
int CBunknownCommand (CAMDESC* cd) 
{
	char msg[260];

	sprintf (msg, "unknown data received. command no: 0x%02x", cd->command); 

	return 0;
}


/****************************************************************************
* CB for data with command number 0x8010									*
*																			*
* default for live image													*
*****************************************************************************/

int CBcommand0x8010 (CAMDESC* cd, int dattyp, int startX, int height, int width, void* pdata)
{
	
	if(g_blSensorRunning)
	{
		if(aktsize.width==width && aktsize.height==height)
		{
			if(liveImg!=NULL)
			{
				if (!Ibuf_full & Start_flag)
				{
					cvSetData(liveImg,pdata,aktsize.width);	
					Ibuf_full = 1;
				}
					cvShowImage("LiveImage",liveImg);
			}
		}
		else
		{
			if(liveImg!=NULL)
			{
				cvReleaseImageHeader(&liveImg);
				liveImg = NULL;
			}
				
			
			//cvNamedWindow("Live Image", CV_WINDOW_AUTOSIZE);
			aktsize.width=width;
			aktsize.height=height;
			liveImg=cvCreateImageHeader(aktsize,IPL_DEPTH_8U,1);  
			if (!Ibuf_full & Start_flag)
			{ 
				cvSetData(liveImg,pdata,aktsize.width);	
				Ibuf_full = 1;
			}
			//cvShowImage("LiveImage",liveImg);
		
	
		}

		//increase the frame number
		++g_iNumFrames;
	}
	
	return 0;
}


/****************************************************************************
* CB for data with command number 0x8020									*
*																			*
* profile image											     				*
*****************************************************************************/

int CBcommand0x8020 (CAMDESC* cd, int dattyp, int startX, int height, int width, void* pdata)
{
	if(g_blSensorRunning)
	{
		int i = 0;
		int k = 0;
		int ret = 0;
		unsigned short* data = NULL;
		unsigned short* pDataProf = NULL;
		unsigned short* pDataInten = NULL;


		// Setup Images for open cv============================================================================
		if((aktsize.width!=width || aktsize.height!=height) && dattyp != DATATYPE_PROFILE_PLUS_INTENSITY)
		{
			if(profImg!=NULL)
			{
				cvReleaseImage(&profImg);
				profImg=NULL;
			}
			if(intenImg!=NULL)
			{
				cvReleaseImage(&intenImg);
				intenImg=NULL;
			}
			aktsize.width=width;
			aktsize.height=height;
			profImg=cvCreateImage(aktsize,IPL_DEPTH_16U,1);
			intenImg=cvCreateImage(aktsize,IPL_DEPTH_16U,1);
		}
		else if((aktsize.width!=(width/2) || aktsize.height!=height) && dattyp == DATATYPE_PROFILE_PLUS_INTENSITY)
		{
			if(profImg!=NULL)
			{
				cvReleaseImage(&profImg);
				profImg=NULL;
			}
			if(intenImg!=NULL)
			{
				cvReleaseImage(&intenImg);
				intenImg=NULL;
			} 
			aktsize.width=width/2;
			aktsize.height=height;

			profImg=cvCreateImage(aktsize,IPL_DEPTH_16U,1);
			intenImg=cvCreateImage(aktsize,IPL_DEPTH_16U,1);
		}

		pDataProf = (unsigned short*)(profImg->imageData);
		pDataInten = (unsigned short*)(intenImg->imageData);
		//====================================================================================================
		// data contents depends on settings of parameter in PROFILE_SETUP and ACQUIRE module
		data = (unsigned short*) pdata;

		// data includes just contour info
		if (dattyp == DATATYPE_PROFILE)
		{
			for (i=0;i<width*height;i++)
			{
				pDataProf[i]=data[i];
			}
		}

		// data includes just intensity info   
		else if (dattyp == DATATYPE_INTENSITY)
		{
			for (i=0;i<width*height;i++)
			{
				pDataInten[i]=data[i];
			}
		}

		// data includes contour AND intensity info
		// and must be separated
		else if (dattyp == DATATYPE_PROFILE_PLUS_INTENSITY)
		{
			for (i=0;i<width*height;i+=2)
			{
				pDataInten[k]=data[i+1];
				pDataProf[k]=data[i];
				k++;
			}

			// update new width
			width /= 2;
		}
		else
		{
			return -1;
		}

		//enable the remapper process when g_showRemapper=1
		if (g_showRemapper == 1)
		{
			//check whether the camera has already a LUT file 
			if (cd->lut != NULL)
			{
				unsigned short intensLineCpy[1280];
				SR_3DPOINT world[1280];

				for(int i = 0;i<height;++i)
				{
					memcpy(intensLineCpy,&pDataInten[i*width],width*sizeof(unsigned short));
				
					//Create World with float X,Y,Z World Data  | dimension [mm] 
					//returns> 0:success  -1:No LUT loaded 
					ret += SR_API_CreateWorldData(cd,startX,width,&pDataProf[i*width],world);
					ret += SR_API_RemapWorldToMatrix(world,intensLineCpy,width,g_camRangeMin, 
						g_camRangeMax,&pDataInten[i*width],&pDataProf[i*width],g_offsetZ,g_scaleZ);

					if(ret < 0)
					{
						g_strMsg = "Cannot create the world coordinate!";
						g_blStrMsg = true;
					}
				}
			}
			else
			{
				g_strMsg = "There is no LUT in the camera.";
				g_blStrMsg = true;
			}
		}


		// Show images ===============================================================
		if(dattyp == DATATYPE_PROFILE || dattyp == DATATYPE_PROFILE_PLUS_INTENSITY)
		{
			if (!Pbuf_full)
			{ 
				_profImg = cvCreateImage(cvGetSize(profImg), IPL_DEPTH_8U, 1);
				Image16To8(profImg,_profImg,-1,-1);
				cvShowImage("ProfilImage",_profImg);
				Pbuf_full = 1;
			}
		}

		if(dattyp == DATATYPE_INTENSITY || dattyp == DATATYPE_PROFILE_PLUS_INTENSITY)
		{
			if (!Intbuf_full)
			{ 
				_intensImg = cvCreateImage(cvGetSize(intenImg), IPL_DEPTH_8U, 1);
				Image16To8(intenImg,_intensImg,-1,-1);
				cvShowImage("IntensityImage",_intensImg);
				Intbuf_full = 1;
			}
		}

		pDataProf=NULL;
		pDataInten=NULL;
/*
		if(_intensImg != NULL)
		{
			cvReleaseImage(&_intensImg);
			_intensImg = NULL;
		}

		if(_profImg != NULL)
		{
			cvReleaseImage(&_profImg);
			_profImg = NULL;
		}
*/
		//increase the frame number
		//++g_iNumFrames;
	g_iNumFrames = g_iNumFrames + height;
		//=============================================================================
	}

	return 0;
}




//convert the 16-bit image to 8-bit image
void Image16To8(IplImage *srcImg,IplImage *destImg,double minVal,double scaleFact)
{
	double _min=0.0;
	double _max=0.0;
	double fact = scaleFact;

	if (minVal<0) // no valid minimum value gives -> calculate one
	{
		cvMinMaxLoc(srcImg,&_min,&_max);
		if (fact < 0)		
		{			
			if (_min!=_max)
			{
				fact = (255.0)/(_max-_min);
			}
			else
			{
				fact = 1.0;
			}
		}		
	}
	else // valid minimum val given
	{
		if (fact < 0)		
		{			
			cvMinMaxLoc(srcImg,&_min,&_max);
			if (_min!=_max)
			{
				fact = (255.0)/(_max-_min);
			}
			else
			{
				fact = 1.0;
			}
		}	
	}

	cvSubS(srcImg,cvScalarAll(_min),srcImg);
	cvConvertScaleAbs(srcImg,destImg,fact);
}
